#
# ex5: word frequency counter with functions
#

import collections

def openFile(filename):
    try:
        fh = open(filename, "r", encoding="ascii")
    except Exception as e:
        print("Can't open my file: %s" % e)
        quit()
    return fh
        
def processFile(fh):
    numWords = 0
    wordFreq = collections.Counter()
    for line in fh:
        words = line.split(" ")
        for word in words:
            wordFreq[word.strip() ] += 1
        numWords = numWords + len(words)
        print("%s" % line, end="")
    fh.close()
    return numWords, wordFreq

def printStats(numWords, wordFreq):
    print("Found %d words" % numWords)
    for word in sorted(wordFreq):
        print("%s occured %d times" % (word, wordFreq[word]) )
    print("-------------------")
    for word in sorted(wordFreq, key=wordFreq.get, reverse=True):
        print("%s occured %d times" % (word, wordFreq[word]) )

def main():
    fh = openFile("c:/temp/input.txt")
    (nw, wf) = processFile(fh)
    printStats(nw, wf)

if __name__ == "__main__":
    main()
