#
# ex6: word frequency counter with Index
#

import collections

def openFile(filename):
    try:
        fh = open(filename, "r", encoding="ascii")
    except Exception as e:
        print("Can't open my file: %s" % e)
        quit()
    return fh
        
def processFile(fh):
    numWords = 0
    wordFreq = collections.Counter()
    wordIndex = collections.defaultdict(set)
    lineNum = 0
    for line in fh:
        lineNum += 1
        words = line.split(" ")
        for word in words:
            word = word.strip()
            wordFreq[word] += 1
            wordIndex[word].add(str(lineNum))
        numWords = numWords + len(words)
        print("%s" % line, end="")
    fh.close()
    return numWords, wordFreq, wordIndex

def printStats(numWords, wordFreq, wordIndex):
    print("Found %d words" % numWords)
    for word in sorted(wordFreq):
        print("%s occured %d times" % (word, wordFreq[word]) )

    for word in wordIndex:
        print("%s appears on lines %s" % (word, ",".join(wordIndex[word])) )
    
def main():
    fh = openFile("c:/temp/input.txt")
    (nw, wf, wi) = processFile(fh)
    printStats(nw, wf, wi)

if __name__ == "__main__":
    main()
