#
# ex6: word frequency counter with Index
#

import collections

class indexer:
    def __init(self):
        pass
    
    def openFile(self, filename):
        try:
            fh = open(filename, "r", encoding="ascii")
        except Exception as e:
            print("Can't open my file: %s" % e)
            quit()
        self.fh = fh
            
    def processFile(self):
        numWords = 0
        wordFreq = collections.Counter()
        wordIndex = collections.defaultdict(set)
        lineNum = 0
        for line in self.fh:
            lineNum += 1
            words = line.split(" ")
            for word in words:
                word = word.strip()
                wordFreq[word] += 1
                wordIndex[word].add(str(lineNum))
            numWords = numWords + len(words)
            print("%s" % line, end="")
        self.fh.close()
        self.stats = (numWords, wordFreq, wordIndex)

    def printStats(self):
        (numWords, wordFreq, wordIndex) = self.stats
        print("Found %d words" % numWords)
        for word in sorted(wordFreq):
            print("%s occured %d times" % (word, wordFreq[word]) )

        for word in wordIndex:
            print("%s appears on lines %s" % (word, ",".join(wordIndex[word])) )
    
def main():
    obj = indexer()
    obj.openFile("c:/temp/input.txt")
    obj.processFile()
    obj.printStats()

if __name__ == "__main__":
    main()
