#!/usr/bin/env python3
# Exercise 12: Make your own REST server with web.py
import collections
import json
import urllib.parse
import web

urls = (
    '/words(.*)', 'Words'
)

class Words:
    def GET(self, path):
        query = urllib.parse.unquote_plus(web.ctx.query[1:])
        param_dict = dict(urllib.parse.parse_qsl(query))
        if path == "/count":
            return self.word_count(param_dict['txt'])
        elif path == "/freq":
            return self.word_freq(param_dict['txt'])
        else:
            return "ERROR: bad REST path %s" % path

    def word_count(self, line: str) -> str:  # see Lesson Two
        return "%d\n" % len(line.split())

    def word_freq(self, line: str) -> str:  # see Lesson Five
        wordFreq = collections.Counter()
        for word in line.split():
            wordFreq[word] += 1
        return json.dumps(wordFreq, indent=4)

if __name__ == "__main__":
    app = web.application(urls, globals())
    app.run()
